import 'package:flutter/material.dart';

//método main() primeiro método executado
void main() {
  runApp(const MeuApp());
}

class MeuApp extends StatelessWidget {
  const MeuApp({super.key});

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'Nome App', //define o nome do app
      //cor do tema
      theme: ThemeData(
        colorScheme:
            ColorScheme.fromSeed(seedColor: Color.fromARGB(255, 59, 85, 192)),
        useMaterial3: true,
      ),
      home: const PaginaInicio(nomeApp: 'Meu APP'),
    );
  }
}

class PaginaInicio extends StatefulWidget {
  const PaginaInicio({super.key, required this.nomeApp});
  final String nomeApp;

  @override
  State<PaginaInicio> createState() => _PaginaInicioState();
}

class _PaginaInicioState extends State<PaginaInicio> {
  final TextEditingController txtN1Controller = TextEditingController();
  final TextEditingController txtN2Controller = TextEditingController();

  String resposta = "";

  @override
  void dispose() {
    // Clean up the controller when the widget is disposed.
    txtN1Controller.dispose();
    txtN2Controller.dispose();

    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        backgroundColor: Theme.of(context).colorScheme.inversePrimary,
        title: Text(widget.nomeApp),
      ),
      body: Center(
        child: componenteFormulario(),
      ),
    );
  }

  componenteTxtNota1() {
    TextField txtNota1 = TextField(
        controller: txtN1Controller,
        //controller: myController,
        decoration: InputDecoration(hintText: 'Nota 1'));
    return txtNota1;
  }

  componenteTxtNota2() {
    TextField txtNota2 = TextField(
        controller: txtN2Controller,
        decoration: const InputDecoration(hintText: 'Nota 2'));
    return txtNota2;
  }

  componenteLblResposta() {
    Text lblResposta = Text("Média: $resposta");
    return lblResposta;
  }

  double calcularMedia(double n1, double n2) {
    double x = n1;
    double y = n2;
    double r = (x + y) / 2;
    return r;
  }

  componenteBtnCalcular() {
    TextButton btn1 = TextButton(
      onPressed: () {
        double x = double.parse(txtN1Controller.text);
        double y = double.parse(txtN2Controller.text);
        double r = calcularMedia(x, y);

        setState(() {
          resposta = r.toString();
        });
      },
      child: const Text("Calcular 1"),
    );
    return btn1;
  }

  componentebtnCalcular2() {
    ElevatedButton btn = ElevatedButton(
      onPressed: () {
        double x = double.parse(txtN1Controller.text);
        double y = double.parse(txtN2Controller.text);
        double r = calcularMedia(x, y);

        setState(() {
          resposta = r.toString();
        });
      },
      child: const Text('Calcular 2'),
    );
    return btn;
  }

  componenteFormulario() {
    return Center(
        child: Column(children: <Widget>[
      componenteTxtNota1(),
      componenteTxtNota2(),
      componenteBtnCalcular(),
      componentebtnCalcular2(),
      componenteLblResposta(),
      /*componenteCheckBox(),
      componenteSlider(),
      componenteSwitch(),
      componenteRadio(),
      criaDropDownButton(),

      */
    ]));
  }
/*
  String gender = "";
  componenteRadio() {
    return Column(
      children: [
        RadioListTile(
          title: Text("Male"),
          value: "male",
          groupValue: gender,
          onChanged: (value) {
            setState(() {
              gender = value.toString();
              resposta = gender.toString();
            });
          },
        ),
        RadioListTile(
          title: Text("Female"),
          value: "female",
          groupValue: gender,
          onChanged: (value) {
            setState(() {
              gender = value.toString();
              resposta = gender.toString();
            });
          },
        ),
        RadioListTile(
          title: Text("Other"),
          value: "other",
          groupValue: gender,
          onChanged: (value) {
            setState(() {
              gender = value.toString();
              resposta = gender.toString();
            });
          },
        )
      ],
    );
  }

  criaDropDownButton() {
    return DropdownButton<String>(
      items: <String>['São josé dos campos', 'Jacareí', 'Caçapava', 'Taubaté']
          .map((String value) {
        return DropdownMenuItem<String>(
          value: value,
          child: Text(value),
        );
      }).toList(),
      onChanged: (String? value) {
        setState(() {
          resposta = value.toString();
        });
      },
    );
  }

  bool isChecked = false;
  componenteCheckBox() {
    Checkbox chk1 = Checkbox(
        checkColor: Colors.white,
        value: isChecked,
        onChanged: (bool? value) {
          setState(() {
            isChecked = value!;
            resposta = isChecked.toString();
          });
        });
    return chk1;
  }

  double valorSlide = 20;
  componenteSlider() {
    Slider sld1 = Slider(
      value: valorSlide,
      min: 0,
      max: 100,
      divisions: 5,
      label: valorSlide.round().toString(),
      onChanged: (double value) {
        setState(() {
          valorSlide = value;
          resposta = valorSlide.toString();
        });
      },
    );
    return sld1;
  }

  bool selecionado = false;
  componenteSwitch() {
    SwitchListTile swt1 = SwitchListTile(
      title: const Text('Leds'),
      value: selecionado,
      onChanged: (bool value) {
        setState(() {
          selecionado = value;
          resposta = selecionado.toString();
        });
      },
    );
    return swt1;
  }

  componenteImagem() {
    return const Image(image: AssetImage('assets/background.png'));
  }
  */
}
